com.io7m.smfj.bytebuffer

## Class SMFByteBufferPackingConfiguration

- java.lang.Object
- - com.io7m.smfj.bytebuffer.SMFByteBufferPackingConfiguration

- All Implemented Interfaces:
    SMFByteBufferPackingConfigurationType

      @Generated(value={"Immutables.generator","SMFByteBufferPackingConfigurationType"})
      public final class SMFByteBufferPackingConfiguration
      extends Object
      implements SMFByteBufferPackingConfigurationType

  The byte buffer packing configuration.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `SMFByteBufferPackingConfiguration.Builder` Builds instances of type `SMFByteBufferPackingConfiguration`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `javaslang.collection.Seq<SMFAttribute>` | `attributesOrdered()` A specification of the sequence of attributes that will be packed into the byte buffer.
    `static SMFByteBufferPackingConfiguration.Builder` | `builder()` Creates a builder for `SMFByteBufferPackingConfiguration`.
    `static SMFByteBufferPackingConfiguration` | `copyOf(SMFByteBufferPackingConfigurationType instance)` Creates an immutable copy of a `SMFByteBufferPackingConfigurationType` value.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `SMFByteBufferPackingConfiguration` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `attributesOrdered`, `packedAttributesByOffset`, `packedAttributesByOrder`, `packedAttributesByName`, `vertexSizeOctets`.
    `static SMFByteBufferPackingConfiguration` | `of(javaslang.collection.Seq<SMFAttribute> attributesOrdered)` Construct a new immutable `SMFByteBufferPackingConfiguration` instance.
    `javaslang.collection.SortedMap<SMFAttributeName,SMFByteBufferPackedAttribute>` | `packedAttributesByName()`
    `javaslang.collection.SortedMap<Integer,SMFByteBufferPackedAttribute>` | `packedAttributesByOffset()`
    `javaslang.collection.Seq<SMFByteBufferPackedAttribute>` | `packedAttributesByOrder()`
    `String` | `toString()` Prints the immutable value `SMFByteBufferPackingConfiguration` with attribute values.
    `int` | `vertexSizeOctets()`
    `SMFByteBufferPackingConfiguration` | `withAttributesOrdered(javaslang.collection.Seq<SMFAttribute> value)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.smfj.bytebuffer.SMFByteBufferPackingConfigurationType

      `checkPreconditions, offsetOctetsForIndex`

- - ### Method Detail

    - #### attributesOrdered

          public javaslang.collection.Seq<SMFAttribute> attributesOrdered()

      A specification of the sequence of attributes that will be packed into the byte buffer. For each vertex in turn, the value of each attribute will be packed (interleaved) into the buffer in the order given by this sequence.
      Specified by:
        `attributesOrdered` in interface `SMFByteBufferPackingConfigurationType`
      Returns:
        The sequence of attributes that will be packed into the byte buffer

    - #### packedAttributesByOffset

          public javaslang.collection.SortedMap<Integer,SMFByteBufferPackedAttribute> packedAttributesByOffset()

      Specified by:
        `packedAttributesByOffset` in interface `SMFByteBufferPackingConfigurationType`
      Returns:
        The packed attributes by octet offset

    - #### packedAttributesByOrder

          public javaslang.collection.Seq<SMFByteBufferPackedAttribute> packedAttributesByOrder()

      Specified by:
        `packedAttributesByOrder` in interface `SMFByteBufferPackingConfigurationType`
      Returns:
        The packed attributes in declaration order

    - #### packedAttributesByName

          public javaslang.collection.SortedMap<SMFAttributeName,SMFByteBufferPackedAttribute> packedAttributesByName()

      Specified by:
        `packedAttributesByName` in interface `SMFByteBufferPackingConfigurationType`
      Returns:
        The packed attributes by name

    - #### vertexSizeOctets

          public int vertexSizeOctets()

      Specified by:
        `vertexSizeOctets` in interface `SMFByteBufferPackingConfigurationType`
      Returns:
        The size of one vertex in octets

    - #### withAttributesOrdered

          public SMFByteBufferPackingConfiguration withAttributesOrdered(javaslang.collection.Seq<SMFAttribute> value)

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `SMFByteBufferPackingConfiguration` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `attributesOrdered`, `packedAttributesByOffset`, `packedAttributesByOrder`, `packedAttributesByName`, `vertexSizeOctets`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `SMFByteBufferPackingConfiguration` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static SMFByteBufferPackingConfiguration of(javaslang.collection.Seq<SMFAttribute> attributesOrdered)

      Construct a new immutable `SMFByteBufferPackingConfiguration` instance.
      Parameters:
        `attributesOrdered` - The value for the `attributesOrdered` attribute
      Returns:
        An immutable SMFByteBufferPackingConfiguration instance

    - #### copyOf

          public static SMFByteBufferPackingConfiguration copyOf(SMFByteBufferPackingConfigurationType instance)

      Creates an immutable copy of a `SMFByteBufferPackingConfigurationType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
      Parameters:
        `instance` - The instance to copy
      Returns:
        A copied immutable SMFByteBufferPackingConfiguration instance

    - #### builder

          public static SMFByteBufferPackingConfiguration.Builder builder()

      Creates a builder for `SMFByteBufferPackingConfiguration`.
      Returns:
        A new SMFByteBufferPackingConfiguration builder

Copyright © 2017 <code@io7m.com> http://io7m.com